part of flutter_kingmed_version_tool;

class DownLoadOverlay{
  final String ? md5;
  String url;
  String path;
  final BuildContext _context;
  late OverlayEntry scanOverLayEntry;
  final DownloadProgressCallback? downloadProgress;
  final DownloadStatusChangeCallback? downloadStatusChange;

  DownLoadOverlay(this._context,this.downloadProgress,this.downloadStatusChange,this.md5,this.url,this.path);

  show() async{

     scanOverLayEntry=new OverlayEntry(builder: (buildcontext){
       return OverLayWidget((){scanOverLayEntry.remove();},downloadProgress,downloadStatusChange,md5,url,path);
     });

     Overlay.of(_context)!.insert(scanOverLayEntry);

  }

}


class OverLayWidget extends StatefulWidget{
  VoidCallback callback;
  final DownloadProgressCallback? downloadProgress;
  final DownloadStatusChangeCallback? downloadStatusChange;
  final String ? md5;
  String url;
  String path;
  OverLayWidget(this.callback,this.downloadProgress,this.downloadStatusChange,this.md5,this.url,this.path);

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return OverLayWidgetState();
  }
}

class OverLayWidgetState extends State<OverLayWidget> with TickerProviderStateMixin{
  late AnimationController _controller;
  double _downloadProgress = 0.0;
  DownloadStatus _downloadStatus = DownloadStatus.none;
  Color themeColor=new Color(0xff00C4AF);

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    _controller=new AnimationController(duration:Duration(milliseconds: 150),vsync: this);

     Future.delayed(Duration.zero,(){
       _controller.forward();
     });

    _downloadApk(widget.url,widget.path);
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build

    return Positioned(
        bottom: 20,
        left: 20,
        child: ScaleTransition(
          scale: _controller,
          alignment: Alignment.center,
          child: Container(
         // padding: EdgeInsets.fromLTRB(16, 12, 0, 12),
          width: 50,
          height: 50,
          alignment: Alignment.center,
          decoration: new BoxDecoration(
              color: new Color(0xff00C4AF),
              boxShadow: [BoxShadow(color: Colors.black26, offset: Offset(0.0, 1.0),blurRadius: 1.0, spreadRadius: 1.0),],
              borderRadius: BorderRadius.circular(100)
          ),

          child:buildProcessBar()


          // Row(
          //    children: [
          //
          //      Icon(Icons.download_rounded, color: themeColor,size: 28,),
          //
          //      SizedBox(
          //        width: 12,
          //      ),
          //
          //     Expanded(
          //       child: Column(
          //        crossAxisAlignment: CrossAxisAlignment.start,
          //        children: [
          //         Text('下载更新中...',style: new TextStyle(
          //            fontSize: 13,
          //            decoration: TextDecoration.none,
          //            fontWeight: FontWeight.bold,
          //            color: Colors.black
          //         ),),
          //          SizedBox(
          //            height: 4,
          //          ),
          //         buildProcessBar()
          //       ],
          //     ),),
          //
          //      Material(
          //        color: Colors.transparent,
          //         child: TextButton(
          //           onPressed: () {
          //
          //             _controller.reverse();
          //             Future.delayed(Duration(milliseconds: 200),(){
          //               widget.callback();
          //             });
          //
          //           },
          //           child: Text('取消',style: new TextStyle(
          //               fontSize: 15,
          //               decoration: TextDecoration.none,
          //               fontWeight: FontWeight.bold,
          //               color: themeColor
          //           ),),
          //         )
          //
          //      )
          //
          //    ],
          // )
        ),)
    );
  }

  Widget buildProcessBar(){
    return  Center(
       child: Stack(
         children: [
            Center(
               child:  SizedBox(
                 width: 40,
                 height: 40,
                 child: CircularProgressIndicator(value: _downloadProgress,valueColor: AlwaysStoppedAnimation<Color>(Colors.white),),
               ),
            ),
            Center(
              child: Text((_downloadProgress*100).toInt().toString()+'%',style: new TextStyle(
                  fontSize: 12,
                  decoration: TextDecoration.none,
                  color: Colors.white
              ),),
            )
         ],
       ),
    );
  }

  ///
  /// 下载apk包
  ///
  _downloadApk(String url, String path) async {
    if (_downloadStatus == DownloadStatus.start ||
        _downloadStatus == DownloadStatus.downloading ||
        _downloadStatus == DownloadStatus.done) {
      // print('当前下载状态：$_downloadStatus,不能重复下载。');
      return;
    }

    _updateDownloadStatus(DownloadStatus.start);

    try {

      var dio = Dio();
      await dio.download(url, path, onReceiveProgress: (int count, int total) {
        if (total == -1) {
          _downloadProgress = 0.01;
        } else {
          widget.downloadProgress?.call(count, total);
          _downloadProgress = count / total.toDouble();
        }
        setState(() {});
        if (_downloadProgress == 1) {
          //下载完成，跳转到程序安装界面
          _updateDownloadStatus(DownloadStatus.done);
          widget.callback();
          FlutterUpgrade.installAppForAndroid(path,widget.md5.toString());

        }
      });
    } catch (e) {
      print('$e');
      _downloadProgress = 0;
      _updateDownloadStatus(DownloadStatus.error,error: e);
       widget.callback();
    }
  }

  _updateDownloadStatus(DownloadStatus downloadStatus, {dynamic error}) {
    _downloadStatus = downloadStatus;
    widget.downloadStatusChange?.call(_downloadStatus, error: error);
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();
    if(_controller!=null){
       _controller.dispose();
    }
  }

}

